global env ;
vlib work

if [regexp {ModelSim ALTERA} [vsim -version]] {
    # Using Altera OEM Version need to add one more library mapping
    set altgxb_path $env(MODEL_TECH)\/../altera/verilog/altgxb ;
    set alt2gxb_path $env(MODEL_TECH)\/../altera/verilog/stratixiigx_hssi ;
    vmap altgxb_ver $altgxb_path ;
    vmap stratixiigx_hssi_ver $alt2gxb_path ;
} else {
    vlog $env(QUARTUS_ROOTDIR)/eda/sim_lib/220model.v 
    vlog $env(QUARTUS_ROOTDIR)/eda/sim_lib/sgate.v 
    vlog $env(QUARTUS_ROOTDIR)/eda/sim_lib/stratixgx_atoms.v 
    vlog $env(QUARTUS_ROOTDIR)/eda/sim_lib/stratixiigx_hssi_atoms.v 
    vlog $env(QUARTUS_ROOTDIR)/eda/sim_lib/stratixiigx_atoms.v 
    vlog $env(QUARTUS_ROOTDIR)/eda/sim_lib/stratixgx_mf.v 
    vlog $env(QUARTUS_ROOTDIR)/libraries/megafunctions/alt2gxb.v 
    vlog $env(QUARTUS_ROOTDIR)/eda/sim_lib/altera_mf.v 
    vlog $env(QUARTUS_ROOTDIR)/eda/sim_lib/nopli.v +define+NO_PLI
    vlog -sv +define+GENERIC_PLL_TIMESCALE_100_FS=1 $env(QUARTUS_ROOTDIR)/eda/sim_lib/altera_lnsim.sv
    vlog $env(QUARTUS_ROOTDIR)/eda/sim_lib/mentor/stratixv_atoms_ncrypt.v
    vlog $env(QUARTUS_ROOTDIR)/eda/sim_lib/stratixv_atoms.v
    vlog $env(QUARTUS_ROOTDIR)/eda/sim_lib/mentor/stratixv_hssi_atoms_ncrypt.v
    vlog $env(QUARTUS_ROOTDIR)/eda/sim_lib/stratixv_hssi_atoms.v
}

        vlog -sv ../testbench/xcvr/altera_xcvr_functions.sv
        vlog -sv ../testbench/xcvr/stratixv_hssi_8g_rx_pcs_rbc.sv
        vlog -sv ../testbench/xcvr/stratixv_hssi_8g_tx_pcs_rbc.sv
        vlog -sv ../testbench/xcvr/stratixv_hssi_common_pcs_pma_interface_rbc.sv
        vlog -sv ../testbench/xcvr/stratixv_hssi_common_pld_pcs_interface_rbc.sv
        vlog -sv ../testbench/xcvr/stratixv_hssi_rx_pcs_pma_interface_rbc.sv
        vlog -sv ../testbench/xcvr/stratixv_hssi_rx_pld_pcs_interface_rbc.sv
        vlog -sv ../testbench/xcvr/stratixv_hssi_tx_pcs_pma_interface_rbc.sv
        vlog -sv ../testbench/xcvr/stratixv_hssi_tx_pld_pcs_interface_rbc.sv
        vlog -sv ../testbench/xcvr/sv_pcs.sv
        vlog -sv ../testbench/xcvr/sv_pcs_ch.sv
        vlog -sv ../testbench/xcvr/sv_pma.sv
        vlog -sv ../testbench/xcvr/sv_reconfig_bundle_merger.sv
	vlog -sv ../testbench/xcvr/sv_reconfig_bundle_to_xcvr.sv
        vlog -sv ../testbench/xcvr/sv_rx_pma.sv
        vlog -sv ../testbench/xcvr/sv_tx_pma.sv
        vlog -sv ../testbench/xcvr/sv_tx_pma_ch.sv
        vlog -sv ../testbench/xcvr/sv_xcvr_avmm.sv
        vlog -sv ../testbench/xcvr/sv_xcvr_custom_native.sv
        vlog -sv ../testbench/xcvr/sv_xcvr_data_adapter.sv
        vlog -sv ../testbench/xcvr/sv_xcvr_native.sv
        vlog -sv ../testbench/xcvr/sv_xcvr_plls.sv

	vlog ../testbench/pattern_gen/*.v
	vlog ../testbench/*.v
	vlog ../testbench/sdi_mc_build/*.vo


if [regexp {ModelSim ALTERA} [vsim -version]] {
    vsim -t ps -L altera_mf_ver -L lpm_ver -L -L sgate_ver -L altgxb_ver -L stratixiigx_hssi_ver -L work tb_sdi_megacore_top
} else {
    vsim -t 100fs -voptargs="+acc" work.tb_sdi_megacore_top -L work -do }

add log -r {sim:/tb_sdi_megacore_top/*}

do wave.do
run -all
pause
